#ifndef LmbfGui_H
#define LmbfGui_H

// cumbia
#include <qulogimpl.h>
#include <cucontrolsfactorypool.h>
class CumbiaPool;
class QuPlotCurve;
// cumbia

#include <QWidget>
#include <quwatcher.h>
#include <tango.h>
#include <quplotmarkercomponent.h>

namespace Ui {
class LmbfGui;
}


#if CUMBIA_QTCONTROLS_VERSION >= 0x010301

class LmbfPlotMarkerFormatter : public QuPlotMarkerFormat_I {
public:
    // QuPlotMarkerFormat_I interface
public:
    QString format(const QuPlotBase *plot, const QList<QwtPlotCurve *> curves, const int index, QString& x, QString& y) const;
};

#endif

class LmbfGui : public QWidget
{
    Q_OBJECT

public:
    explicit LmbfGui(CumbiaPool *cu_p, QWidget *parent = 0);
    ~LmbfGui();
public slots:
    void update_num_turns(double);
    void update_sevr(QString);

private slots:
    void setCurveSticksStyle(QuPlotCurve *);
    void setFillArea(QuPlotCurve *c);
    void scale_change();
    
protected:
    QPalette normalpalette;
    QPalette alarmpalette;

private:
    Ui::LmbfGui *ui;
    QuWatcher *turns_reader;
    QuWatcher *sevr_reader;
    double num_turns;

    CumbiaPool *cu_pool;
    QuLogImpl m_log_impl;
    CuControlsFactoryPool m_ctrl_factory_pool;

};

#endif // LmbfGui_H

